/***************************************************************************
        dialoglameoptions.h  -  Dialog for setting specific Lame options
       ------------------------------------------------------------------
    begin                : Sat Mar 31 2001
    copyright            : (C) 2001 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOGLAMEOPTIONS_H
#define DIALOGLAMEOPTIONS_H

#include <gtk--/window.h>
#include <gtk--/frame.h>
#include <gtk--/box.h>
#include <gtk--/label.h>
#include <gtk--/button.h>
#include <gtk--/buttonbox.h>
#include <gtk--/tooltips.h>
#include <gtk--/menu.h>
#include <gtk--/checkbutton.h>
#include <gtk--/entry.h>
#include <gtk--/radiobutton.h>

#include <gnome--/stock.h>
#include <libgnome/gnome-i18n.h>
//#include <gnome--/file-entry.h>

#include <sigc++/signal_system.h>
#include <string>
#include <vector>

/**Specific Lame encoder parameters can be selected in this dialog.
  *@author Ladislav Slezk
  */

class DialogLameOptions : public Gtk::Window {

  public:

	  DialogLameOptions();
  	~DialogLameOptions();
  	
  	vector<string> get_lame_parameters();
  	
  private:

    Gtk::CheckButton *bit_reservoir;
    Gtk::RadioButton *q_high, *q_normal, *q_low;

    Gtk::CheckButton *filter_all_freqs;
    Gtk::CheckButton *filter_lowpass_cutoff, *filter_lowpass_width;
    Gtk::Entry *filter_lowpass_cutoff_entry, *filter_lowpass_width_entry;
    Gtk::CheckButton *filter_highpass_cutoff, *filter_highpass_width;
    Gtk::Entry *filter_highpass_cutoff_entry, *filter_highpass_width_entry;
    Gtk::CheckButton *filter_tonality;
    Gtk::Entry *filter_tonality_entry;

    Gtk::Label *low_kHz, *low_w_kHz, *high_kHz, *high_w_kHz, *tonality_kHz;

    Gtk::Tooltips *tips;

    void button_pressed();

    void all_frequencies();
    void low_cutoff();
    void low_width();
    void high_cutoff();
    void high_width();
    void tonality();
  	
};

#endif
