/***************************************************************************
                   dialogoptions.h  -  Quickedit options dialog
                  ----------------------------------------------
    begin                : Fri Apr 20 2001
    copyright            : (C) 2001 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOGOPTIONS_H
#define DIALOGOPTIONS_H

#include <gtk--/window.h>
#include <gtk--/box.h>
#include <gtk--/buttonbox.h>
#include <gtk--/button.h>
#include <gtk--/frame.h>
#include <gtk--/label.h>
#include <gtk--/checkbutton.h>
#include <gtk--/table.h>
#include <gtk--/notebook.h>
#include <gtk--/entry.h>
#include <gtk--/tooltips.h>

#include <gdk--/color.h>

#include <gnome--/stock.h>
#include <gnome--/color-picker.h>
#include <gnome--/entry.h>
#include <gnome--/file-entry.h>

#include <libgnome/gnome-i18n.h>

#include <string>

/**Dialog for setting options
  *@author Ladislav Slezk
  */

class DialogOptions : public Gtk::Window {

  public:

	  DialogOptions();
  	~DialogOptions();
  	
  	void set_defaults();
		SigC::Signal0<void> ok_pressed;    // signal OK pressed

  	string get_mpg123_path() {return gentry_mpg123->get_entry()->get_text();}
  	string get_lame_path() {return gentry_lame->get_entry()->get_text();}
  	string get_sox_path() {return gentry_sox->get_entry()->get_text();}
  	bool get_use_wheel() {return use_wheel->get_active();}
  	Gdk_Color get_foreground_color();
  	Gdk_Color get_background_color();
		string get_oss_device() {return oss_file->get_text();}
		string get_end_time() {return end_time->get_text();}
  	bool get_mp3_always_process() {return mp3_export_always_process->get_active();}
  	bool get_mp3_strict_equal() {return !mp3_export_always_process->get_active() & mp3_export_strictequal->get_active();}
  	
  	void set_mpg123_path(string path) {gentry_mpg123->get_entry()->set_text(path);}
  	void set_lame_path(string path) {gentry_lame->get_entry()->set_text(path);}
  	void set_sox_path(string path) {gentry_sox->get_entry()->set_text(path);}
  	void set_use_wheel(bool use) {use_wheel->set_active(use);}
  	void set_foreground_color(Gdk_Color c);
  	void set_background_color(Gdk_Color c);
		void set_oss_device(string dev) {oss_file->set_text(dev);}
		void set_end_time(string t) {end_time->set_text(t);}
  	void set_mp3_always_process(bool process) {mp3_export_always_process->set_active(process); no_copy();}
  	void set_mp3_strict_equal(bool strict_eq) {mp3_export_strictequal->set_active(strict_eq);}

  private:

    void button_pressed(bool ok);
    void no_copy();

    Gtk::CheckButton *use_wheel, *mp3_export_always_process, *mp3_export_strictequal;
    Gnome::ColorPicker *fgpicker, *bgpicker;
    Gnome::FileEntry *entry_mpg123, *entry_lame, *entry_sox;
    Gnome::Entry *gentry_mpg123, *gentry_lame, *gentry_sox;
    Gtk::Entry *oss_file;
    Gtk::Entry *end_time;

    int delete_event_impl(GdkEventAny* e);

};

#endif
