/***************************************************************************
            dialogtageditor.h  -  Dialog for setting ID3 tag values
           ---------------------------------------------------------
    begin                : Sat Mar 31 2001
    copyright            : (C) 2001 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOGTAGEDITOR_H
#define DIALOGTAGEDITOR_H

#include <gtk--/window.h>
#include <gtk--/frame.h>
#include <gtk--/box.h>
#include <gtk--/label.h>
#include <gtk--/button.h>
#include <gtk--/buttonbox.h>
#include <gtk--/entry.h>
#include <gtk--/combo.h>
#include <gtk--/table.h>

#include <gnome--/stock.h>
#include <libgnome/gnome-i18n.h>

#include <sigc++/signal_system.h>
#include <string>
#include <vector>

/**ID3 tag editor dialog
  *@author Ladislav Slezk
  */

class DialogTagEditor : public Gtk::Window {

  public:

  	DialogTagEditor();
	  ~DialogTagEditor();
	
	  string get_title() {return entry_title->get_text();}
	  string get_artist() {return entry_artist->get_text();}
	  string get_album() {return entry_album->get_text();}
	  string get_comment() {return entry_comment->get_text();}
	  string get_year() {return entry_year->get_text();}
    char get_genre();

 		SigC::Signal0<void> ok_clicked;

	  	
  private:

    Gtk::Entry *entry_title;
    Gtk::Entry *entry_artist;
    Gtk::Entry *entry_album;
    Gtk::Entry *entry_comment;
    Gtk::Entry *entry_year;
    Gtk::Combo *combo_genre;
    vector<string> combo_list;

    void button_pressed();

    int delete_event_impl(GdkEventAny* e);

};

#endif
