/***************************************************************************
      dialogvbroptions.h  -  Dialog for setting VBR encoding options
     ----------------------------------------------------------------
    begin                : Sat Mar 31 2001
    copyright            : (C) 2001 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOGVBROPTIONS_H
#define DIALOGVBROPTIONS_H

#include <gtk--/window.h>
#include <gtk--/frame.h>
#include <gtk--/box.h>
#include <gtk--/label.h>
#include <gtk--/button.h>
#include <gtk--/buttonbox.h>
#include <gtk--/optionmenu.h>
#include <gtk--/menu.h>
#include <gtk--/menuitem.h>
#include <gtk--/checkbutton.h>
//#include <gtk--/table.h>

#include <gnome--/stock.h>
#include <libgnome/gnome-i18n.h>
//#include <gnome--/file-entry.h>

#include <sigc++/signal_system.h>
#include <string>
#include <vector>


/**Dialog for setting VBR options
  *@author Ladislav Slezk
  */

class DialogVBRoptions : public Gtk::Window {

  public:

  	DialogVBRoptions();
	  ~DialogVBRoptions();
	
	  void set_sampling_frequency(int f);
	  vector<string> get_vbr_options();
	
  private:

    Gtk::CheckButton *min_br;
    Gtk::CheckButton *max_br;
    Gtk::CheckButton *vbr_info;

    Gtk::MenuItem *min_br8, *min_br16, *min_br24, *min_br32, *min_br40, *min_br48, *min_br56,
                  *min_br64, *min_br80, *min_br96, *min_br112, *min_br128, *min_br144, *min_br160,
                  *min_br192, *min_br224, *min_br256, *min_br320;

    Gtk::MenuItem *max_br8, *max_br16, *max_br24, *max_br32, *max_br40, *max_br48, *max_br56,
                  *max_br64, *max_br80, *max_br96, *max_br112, *max_br128, *max_br144, *max_br160,
                  *max_br192, *max_br224, *max_br256, *max_br320;

    Gtk::OptionMenu *max_bitrate_optionmenu;
    Gtk::Menu *max_bitrate_menu;

    Gtk::OptionMenu *min_bitrate_optionmenu;
    Gtk::Menu *min_bitrate_menu;

    int min_bitrate;
    int max_bitrate;
    int quality;

    void min_bitrate_changed(int br);
    void max_bitrate_changed(int br);
    void min_bitrate_sensitive();
    void max_bitrate_sensitive();
    void quality_changed(int q);
    void button_pressed();

    int delete_event_impl(GdkEventAny* e);
};

#endif
