/***************************************************************************
                       view.h  -  waveform widget
                      ----------------------------
    begin                : Sun Jul 23 2000
    copyright            : (C) 2000 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VIEW_H
#define VIEW_H

#include <sigc++/signal_system.h>
#include <gtk--/style.h>
#include <gtk--/drawingarea.h>
#include <gdk/gdktypes.h>
#include <gdk--/color.h>

/**
  *@author Ladislav Slezk
  */

class View : public Gtk::DrawingArea {

  public:

	  View();
	  ~View();
	
	  Gdk_Pixmap *get_pixmap() {return &pixmap;}
	  Gdk_GC get_GC() {return fgc;}
	  void clear();
	  void refresh();
	  void draw_pos(int);
	  void draw_selection(int, int);
    void clear_pos();
    void clear_selection();
    void set_foreground_color(Gdk_Color c);
    void set_background_color(Gdk_Color c);

 		SigC::Signal0<void> reconfigured;
 		
	  	
	private:
	
    Gdk_Pixmap pixmap;
    Gdk_GC fgc, bgc;
    Gdk_Window window;

    Gdk_Color fgcolor, bgcolor;

    bool position_visible;
    bool selection_visible;
    int pos;
    int sel1, sel2;

    virtual gint configure_event_impl (GdkEventConfigure *event);
    virtual gint expose_event_impl (GdkEventExpose *event);
};

#endif
